local M = {}

local Number = 12345678910

local function SUPER_ENGINE(GM, MORE_POWER, SMOOTH, Multiplier)
	local aisp = electrics.values.airspeed * 3.6
	for _, device in pairs(powertrain.getDevices()) do
		local Coeff = device.torqueLossCoef
		if (GM == true and device.clutchMaxSafeTemp ~= Number) then
			device.maxPhysicalAV = Number
			device.maxTorqueRating = Number
			device.maxOverTorqueDamage = Number
			device.clutchPermanentDamageTempThreshold = Number
			device.clutchCoolingCoef = 5000
			device.clutchWarningTemp = Number
			device.clutchMaxSafeTemp = Number
			device.gearDamageThreshold = Number
			device.canFlood = false
			device.thermals = require("powertrain/OFF_thermals")
			device.thermals.OFF_thermals()
		end
		if (GM == false and device.clutchMaxSafeTemp == Number) then
			obj:queueGameEngineLua('be:reloadVehicle(0)')
			obj:queueGameEngineLua([[be:executeJS('document.getElementById("Coeff").innerHTML = "Coeff = " + "nil"')]])
		end
		if MORE_POWER then
			if (aisp < 15) then Coeff = 0.001 end
			if SMOOTH then if (aisp >= 015) then Coeff = aisp / 200 end else 
				--if (aisp >= 015) then Coeff = math.log10(aisp) / math.log10(15) end
				if (aisp >= 015) then Coeff = 1.000 end
				if (aisp >= 050) then Coeff = 1.250 end
				if (aisp >= 100) then Coeff = 1.500 end
				if (aisp >= 150) then Coeff = 1.625 end
				if (aisp >= 200) then Coeff = 1.750 end
				if (aisp >= 250) then Coeff = 1.875 end
				if (aisp >= 300) then Coeff = 2.000 end
				if (aisp >= 350) then Coeff = 2.125 end
				if (aisp >= 400) then Coeff = 2.250 end
				if (aisp >= 450) then Coeff = 2.375 end
				if (aisp >= 500) then Coeff = 2.500 end
			end
			if (Coeff > 2.5) then Coeff = 2.5 end
			Coeff = -1 * math.ceil(Coeff * 1000)/1000 * Multiplier
			if (device.torqueLossCoef ~= Coeff) then device.torqueLossCoef = Coeff obj:queueGameEngineLua(string.format([[be:executeJS('document.getElementById("Coeff").innerHTML = "Coeff = " + %s')]], Coeff * -1)) end
		else
			if (Coeff == nil) then return else
			if (Coeff < 0) then device.torqueLossCoef = 0.01 obj:queueGameEngineLua(string.format([[be:executeJS('document.getElementById("Coeff").innerHTML = "Coeff = " + %s')]], 0.01)) end
			if (Coeff > 0) then return end end
		end
	end
end

M.Аctivation_Сheck = Аctivation_Сheck
M.SUPER_ENGINE = SUPER_ENGINE
return M