angular.module('beamng.apps')
.directive('cheatPanel', [function () {
  return {
	templateUrl: '/ui/modules/apps/cheatPanel/app.html',
	replace: true,

  link: function (scope, element) {
	window.onerror = myOnError;
	function myOnError(msg, url, lno) {return true};
	let fix024 = setTimeout ( () => {
		document.getElementById('checkbox1').style.filter = 'invert(95%)';
		document.getElementById('checkbox2').style.filter = 'invert(95%)';
		document.getElementById('checkbox3').style.filter = 'invert(95%)';
		document.getElementById('checkbox4').style.filter = 'invert(95%)';
		document.getElementById('checkbox5').style.filter = 'invert(95%)';
		document.getElementById('checkbox6').style.filter = 'invert(95%)';
		document.getElementById('checkbox7').style.filter = 'invert(95%)';
		document.getElementById('checkbox8').style.filter = 'invert(95%)';
		document.getElementById('checkbox9').style.filter = 'invert(95%)';

		document.getElementById('Multiplier_input').style.backgroundColor = 'white';
		document.getElementById('Multiplier_input').style.color = 'black';
	},10);

	let lang = function () {return vueI18n.global.locale},
	GameVersions = Number(beamng.versionshort.substr(2,2));
	if (GameVersions > 24) {
		Update();
		return
	};
	scope.Invisibility = false;
	let RAINBOW_TEXT_R = 1000,
	RAINBOW_TEXT_G = 0,
	RAINBOW_TEXT_B = 0;
	scope.ON_OFF_RAINBOW = false;
	scope.Roughness = 25;
	scope.Roughness_lvl_change = function () {document.getElementById('Roughness_lvl').innerHTML = scope.Roughness + '%'};
	scope.Color_change_speed = 100;
	scope.Color_change_speed_lvl_change = function () {document.getElementById('Color_change_speed_lvl').innerHTML = scope.Color_change_speed + '%'};
	scope.Game_speed = 1.0;
	scope.Game_speed_change = function () {document.getElementById('Game_speed_X').innerHTML = 'X' + scope.Game_speed; bngApi.engineLua('be:setSimulationTimeScale(' + scope.Game_speed + ')')};
	scope.ON_OFF_DRIFT = false;
	scope.ON_OFF_DRAG = false;
	scope.ON_OFF_WTF = false;
	bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')');
	scope.X2_Shadow_Quality = false;
	scope.RUN_X2_Shadow_Quality = function () {bngApi.engineLua('scripts_cheatPanel_extension.X2_Shadow_Quality(' + scope.X2_Shadow_Quality + ')'); if (scope.X2_Shadow_Quality){document.getElementById('checkbox6').style.filter = 'invert(0%)'}else{document.getElementById('checkbox6').style.filter = 'invert(95%)'}};
	scope.ON_OFF_SUPER_ENGINE = false;
	scope.ON_OFF_MORE_POWER = false;
	scope.ON_OFF_MORE_POWER_SMOOTH = false;
	scope.Multiplier = 1.0;

	scope.RUN_Invisibility = function () {
		let Invisibility = setTimeout( () => {
			if (scope.Invisibility) {
				document.getElementById('checkbox1').style.filter = 'invert(0%)';
				bngApi.engineLua('be:getPlayerVehicle(0):setMeshAlpha(0, "")');
				scope.RUN_Invisibility()
			} else {
				bngApi.engineLua('be:getPlayerVehicle(0):setMeshAlpha(1, "")');
				document.getElementById('checkbox1').style.filter = 'invert(95%)';
				clearTimeout(Invisibility)
			}
		}, 8)
	};
	scope.RUN_ON_OFF_RAINBOW = function () {
		let RAINBOW_Time_Interval = setTimeout( () => {
			if (scope.ON_OFF_RAINBOW) {
				document.getElementById('checkbox2').style.filter = 'invert(0%)';
				if (RAINBOW_TEXT_R == 1000 && RAINBOW_TEXT_G < 1000  && RAINBOW_TEXT_B == 0000) {RAINBOW_TEXT_G += scope.Color_change_speed * 0.1};
				if (RAINBOW_TEXT_R > 0000  && RAINBOW_TEXT_G == 1000 && RAINBOW_TEXT_B == 0000) {RAINBOW_TEXT_R -= scope.Color_change_speed * 0.1};
				if (RAINBOW_TEXT_R == 0000 && RAINBOW_TEXT_G == 1000 && RAINBOW_TEXT_B <  1000) {RAINBOW_TEXT_B += scope.Color_change_speed * 0.1};
				if (RAINBOW_TEXT_R == 0000 && RAINBOW_TEXT_G > 0000  && RAINBOW_TEXT_B == 1000) {RAINBOW_TEXT_G -= scope.Color_change_speed * 0.1};
				if (RAINBOW_TEXT_R < 1000  && RAINBOW_TEXT_G == 0000 && RAINBOW_TEXT_B == 1000) {RAINBOW_TEXT_R += scope.Color_change_speed * 0.1};
				if (RAINBOW_TEXT_R == 1000 && RAINBOW_TEXT_G == 0000 && RAINBOW_TEXT_B >  0000) {RAINBOW_TEXT_B -= scope.Color_change_speed * 0.1};

				if (RAINBOW_TEXT_R > 1000) {RAINBOW_TEXT_R = 1000};
				if (RAINBOW_TEXT_R < 0000) {RAINBOW_TEXT_R = 0000};
				if (RAINBOW_TEXT_G > 1000) {RAINBOW_TEXT_G = 1000};
				if (RAINBOW_TEXT_G < 0000) {RAINBOW_TEXT_G = 0000};
				if (RAINBOW_TEXT_B > 1000) {RAINBOW_TEXT_B = 1000};
				if (RAINBOW_TEXT_B < 0000) {RAINBOW_TEXT_B = 0000};

				document.getElementById('CHEAT_PANEL').style.color = 'rgba(' + RAINBOW_TEXT_R * 0.255 + ',' + RAINBOW_TEXT_G * 0.255 + ',' + RAINBOW_TEXT_B * 0.255 + ',1.0)';
				bngApi.engineLua('scripts_cheatPanel_extension.Rainbow_Mode(' + RAINBOW_TEXT_R + ',' + RAINBOW_TEXT_G + ',' + RAINBOW_TEXT_B + ',' + scope.Roughness / 100 + ')');
				scope.RUN_ON_OFF_RAINBOW()
			} else {
				document.getElementById('checkbox2').style.filter = 'invert(95%)';
				clearTimeout(RAINBOW_Time_Interval)
			}
		}, 8)
	};

	scope.RUN_ON_OFF_DRIFT = function () {
		if (scope.ON_OFF_DRAG)   {scope.ON_OFF_DRAG = false;  bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')'); document.getElementById('checkbox4').style.filter = 'invert(95%)'};
		if (scope.ON_OFF_WTF)    {scope.ON_OFF_WTF = false;   bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')'); document.getElementById('checkbox5').style.filter = 'invert(95%)'};
		if (scope.ON_OFF_DRIFT)  {							  bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 1 + ')'); document.getElementById('checkbox3').style.filter = 'invert(00%)'};
		if (!scope.ON_OFF_DRIFT) {							  bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')'); document.getElementById('checkbox3').style.filter = 'invert(95%)'};
	};
	scope.RUN_ON_OFF_DRAG = function () {
		if (scope.ON_OFF_DRIFT)  {scope.ON_OFF_DRIFT = false; bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')'); document.getElementById('checkbox3').style.filter = 'invert(95%)'};
		if (scope.ON_OFF_WTF)    {scope.ON_OFF_WTF = false;   bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')'); document.getElementById('checkbox5').style.filter = 'invert(95%)'};
		if (scope.ON_OFF_DRAG)   {							  bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 2 + ')'); document.getElementById('checkbox4').style.filter = 'invert(00%)'};
		if (!scope.ON_OFF_DRAG)  {							  bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')'); document.getElementById('checkbox4').style.filter = 'invert(95%)'};
	};
	scope.RUN_ON_OFF_WTF = function () {
		if (scope.ON_OFF_DRIFT)  {scope.ON_OFF_DRIFT = false; bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')'); document.getElementById('checkbox3').style.filter = 'invert(95%)'};
		if (scope.ON_OFF_DRAG)   {scope.ON_OFF_DRAG = false;  bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')'); document.getElementById('checkbox4').style.filter = 'invert(95%)'};
		if (scope.ON_OFF_WTF)    {							  bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 3 + ')'); document.getElementById('checkbox5').style.filter = 'invert(00%)'};
		if (!scope.ON_OFF_WTF)   {							  bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')'); document.getElementById('checkbox5').style.filter = 'invert(95%)'};
	};

	scope.RUN_SUPER_ENGINE = function () {
		let SUPER_ENGINE_Time_Interval = setTimeout( () => {
			if (scope.ON_OFF_SUPER_ENGINE) {
				document.getElementById('checkbox7').style.filter = 'invert(0%)';
				bngApi.activeObjectLua('extensions.cheatPanel.SUPER_ENGINE(' + scope.ON_OFF_SUPER_ENGINE + ',' + scope.ON_OFF_MORE_POWER + ',' + scope.ON_OFF_MORE_POWER_SMOOTH + ',' + scope.Multiplier + ')');
				scope.RUN_SUPER_ENGINE()
			} else {
				document.getElementById('checkbox7').style.filter = 'invert(95%)';
				bngApi.activeObjectLua('extensions.cheatPanel.SUPER_ENGINE(' + scope.ON_OFF_SUPER_ENGINE + ',' + scope.ON_OFF_MORE_POWER + ',' + scope.ON_OFF_MORE_POWER_SMOOTH + ',' + scope.Multiplier + ')');
				clearTimeout(SUPER_ENGINE_Time_Interval)}
		}, 8)
	};
	scope.RUN_ON_OFF_MORE_POWER = function () {if (scope.ON_OFF_MORE_POWER) {document.getElementById('checkbox8').style.filter = 'invert(0%)'} else {document.getElementById('checkbox8').style.filter = 'invert(95%)'}};
	scope.RUN_ON_OFF_MORE_POWER_SMOOTH = function () {if (scope.ON_OFF_MORE_POWER_SMOOTH) {document.getElementById('checkbox9').style.filter = 'invert(0%)'} else {document.getElementById('checkbox9').style.filter = 'invert(95%)'}};
	scope.Reload = function () {
		bngApi.engineLua(`
			be:reloadVehicle(0)
			reloadUI()
			be:setSimulationTimeScale(1)
		`);
		bngApi.engineLua('scripts_cheatPanel_extension.X2_Shadow_Quality(' + false + ')')
	};

	function Update () {
		let text_upd;
		if (lang() == 'ru_RU') {text_upd = 'Обновите мод'} else {text_upd = 'Please update mod'};
		document.getElementById('CHEAT_PANEL').innerHTML = text_upd;
		document.getElementById('Invisibility').innerHTML = text_upd;
		document.getElementById('ON_OFF_RAINBOW').innerHTML = text_upd;
		document.getElementById('Roughness').innerHTML = text_upd;
		document.getElementById('Color_change_speed').innerHTML = text_upd;
		document.getElementById('Game_speed').innerHTML = text_upd;
		document.getElementById('ON_OFF_DRIFT').innerHTML = text_upd;
		document.getElementById('ON_OFF_DRAG').innerHTML = text_upd;
		document.getElementById('ON_OFF_WTF').innerHTML = text_upd;
		document.getElementById('X2_Shadow_Quality').innerHTML = text_upd;
		document.getElementById('ON_OFF_SUPER_ENGINE').innerHTML = text_upd;
		document.getElementById('Reload').innerHTML = text_upd;
		document.getElementById('ON_OFF_MORE_POWER').innerHTML = text_upd;
		document.getElementById('ON_OFF_MORE_POWER_SMOOTH').innerHTML = text_upd;
		document.getElementById('Multiplier').innerHTML = text_upd
	};

	let translation = setTimeout( () => {
		if (lang() == 'ru_RU') {
			document.getElementById('Invisibility').innerHTML = 'Невидимость';
			document.getElementById('ON_OFF_RAINBOW').innerHTML = 'Включение режима радуги';
			document.getElementById('Roughness').innerHTML = 'Шероховатость';
			document.getElementById('Roughness').style.fontSize= '11px';
			document.getElementById('Roughness').style.marginTop = '-2px';
			document.getElementById('Roughness').style.height = '16px';
			document.getElementById('Color_change_speed').innerHTML = 'Скорость смены цвета';
			document.getElementById('Game_speed').innerHTML = 'Скорость игры';
			document.getElementById('Game_speed').style.fontSize = '12px';
			document.getElementById('ON_OFF_DRIFT').innerHTML = 'Включение дрифт режима';
			document.getElementById('ON_OFF_DRAG').innerHTML = 'Включение драг режима';
			document.getElementById('ON_OFF_WTF').innerHTML = 'Включение WTF режима';
			document.getElementById('X2_Shadow_Quality').innerHTML = 'Качество теней X2';
			document.getElementById('ON_OFF_SUPER_ENGINE').innerHTML = 'Неразрушаемый двигатель';
			document.getElementById('Reload').innerHTML = 'Перезагрузка';
			document.getElementById('Reload').style.fontSize = '13px';
			document.getElementById('Reload').style.marginLeft = '208px';
			document.getElementById('Reload').style.width = '83px';
			document.getElementById('Reload_button').style.marginLeft = '206px';
			document.getElementById('Reload_button').style.minWidth = '93px';
			document.getElementById('Reload_button').style.Width = '93px';
			document.getElementById('Reload_button').style.maxWidth = '93px';
			document.getElementById('ON_OFF_MORE_POWER').innerHTML = 'БОЛЬШЕ МОЩИ!!!';
			document.getElementById('ON_OFF_MORE_POWER_SMOOTH').innerHTML = 'Плавно';
			document.getElementById('Multiplier').innerHTML = 'Множитель для множителя 🙂';
			document.getElementById('Author').innerHTML = 'By Ns Pro'
		};
	},2000);
	}}}]);